Subject: Re: bug#56323: 29.0.50; [v2] Add new customisable phonetic Tamil input method

From: Eli Zaretskii <[email-masked]>
Date: Fri, 01 Jul 2022 17:06:36 +0300

> From: Visuwesh <[email-masked]>
> Cc: [email-masked]
> Date: Fri, 01 Jul 2022 19:17:18 +0530
> 
> > Then you'll need to write your own comparison function and use it
> > instead string-lessp.
> >
> 
> I suppose so.  How does the following look?
> 
>     (sort
>      '("க்" "ங்" "ச்" "ஞ்" "ட்" "ண்" "ற்ற்" "ந்" "ப்" "ய்"
>        "ம்" "த்" "ர்" "ல்" "வ்" "ள்" "ற்" "ழ்" "ன்"
>        "ஸ்" "ஜ்" "க்ஷ்" "ஷ்" "ஹ்" "க்‌ஷ்" "ஶ்")
>      (lambda (x y)
>        (let* ((cp '(("க்" . 0) ("ங்" . 1) ("ச்" . 2) ("ஞ்" . 3) ("ட்" . 4) ("ண்" . 5)
>                     ("த்" . 6) ("ந்" . 7) ("ப்" . 8) ("ம்" . 9) ("ய்" . 10) ("ர்" . 11)
>                     ("ல்" . 12) ("வ்" . 13) ("ழ்" . 14) ("ள்" . 15) ("ற்" . 16) ("ன்" . 17)
>                     ("ஜ்" . 18) ("ஸ்" . 19) ("ஷ்" . 20) ("ஹ்" . 21) ("க்ஷ்" . 22)
>                     ("க்‌ஷ்" . 23) ("ஶ்" . 24)))
>               (xp (or (assoc-default x cp nil) 10000))
>               (yp (or (assoc-default y cp nil) 10000)))
>          (< xp yp))))

I don't think I understand what you want to achieve, and don't read
Tamil in the first place, to tell you whether this is correct or not,
sorry.

> >> Can I use the min-width property in buffer text?
> >
> > Why do you need that?  Please tell more about what you want to
> > accomplish.
> 
> Currently we don't try too hard to ensure that text don't bump into each
> other in the tables we calculate.  If you are unlucky, then the table
> will be incomprehensible so I thought about putting a reasonable
> min-width value on the text in signs table at least.  Of course, finding
> a reasonable value is a headache in of itself; the better solution would
> be probably pulling in the vtable library but I'm not too sure about
> that.

I think it would be better to be more accurate in alignment of table
cells.  We do have string-width and string-pixel-width, let alone
window-text-pixel-size.

> I also attached a screenshot comparing my running Emacs session and
> emacs -Q (yellow window is my current Emacs session) to get the point
> across better.

Looks like simple misalignment to me, which should be cured by using
pixel-resolution alignment features.